/*
 * generated by Xtext 2.19.0.M3
 */
package fr.irisa.cairn.graphviz.model.serializer;

import com.google.inject.Inject;
import fr.irisa.cairn.graphviz.model.services.DottyGrammarAccess;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AlternativeAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public class DottySyntacticSequencer extends AbstractSyntacticSequencer {

	protected DottyGrammarAccess grammarAccess;
	protected AbstractElementAlias match_ColorAttribute_ColorKeyword_0_0_or_FillcolorKeyword_0_1_or_FontcolorKeyword_0_2;
	protected AbstractElementAlias match_Compound_SemicolonKeyword_1_1_q;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (DottyGrammarAccess) access;
		match_ColorAttribute_ColorKeyword_0_0_or_FillcolorKeyword_0_1_or_FontcolorKeyword_0_2 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getColorAttributeAccess().getColorKeyword_0_0()), new TokenAlias(false, false, grammarAccess.getColorAttributeAccess().getFillcolorKeyword_0_1()), new TokenAlias(false, false, grammarAccess.getColorAttributeAccess().getFontcolorKeyword_0_2()));
		match_Compound_SemicolonKeyword_1_1_q = new TokenAlias(false, true, grammarAccess.getCompoundAccess().getSemicolonKeyword_1_1());
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		return "";
	}
	
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if (match_ColorAttribute_ColorKeyword_0_0_or_FillcolorKeyword_0_1_or_FontcolorKeyword_0_2.equals(syntax))
				emit_ColorAttribute_ColorKeyword_0_0_or_FillcolorKeyword_0_1_or_FontcolorKeyword_0_2(semanticObject, getLastNavigableState(), syntaxNodes);
			else if (match_Compound_SemicolonKeyword_1_1_q.equals(syntax))
				emit_Compound_SemicolonKeyword_1_1_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * Ambiguous syntax:
	 *     'color' | 'fillcolor' | 'fontcolor'
	 *
	 * This ambiguous syntax occurs at:
	 *     (rule start) (ambiguity) '=' color=ID
	 *     (rule start) (ambiguity) '=' color=STRING
	 */
	protected void emit_ColorAttribute_ColorKeyword_0_0_or_FillcolorKeyword_0_1_or_FontcolorKeyword_0_2(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     ';'?
	 *
	 * This ambiguous syntax occurs at:
	 *     attributes+=Attribute (ambiguity) '}' (rule end)
	 *     attributes+=Attribute (ambiguity) attributes+=Attribute
	 *     attributes+=Attribute (ambiguity) nodes+=Node
	 *     attributes+=Attribute (ambiguity) sub+=Compound
	 *     nodes+=Node (ambiguity) '}' (rule end)
	 *     nodes+=Node (ambiguity) attributes+=Attribute
	 *     nodes+=Node (ambiguity) nodes+=Node
	 *     nodes+=Node (ambiguity) sub+=Compound
	 *     sub+=Compound (ambiguity) '}' (rule end)
	 *     sub+=Compound (ambiguity) attributes+=Attribute
	 *     sub+=Compound (ambiguity) nodes+=Node
	 *     sub+=Compound (ambiguity) sub+=Compound
	 */
	protected void emit_Compound_SemicolonKeyword_1_1_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
